(function ($) {
  'use strict';
  $(document).ready(function () {

    $('.disabledClick').click(false);
    $(window).on("load", function () {
        $(document).on('click', '#vpc-save-config', function () {
                $('#debug').html('');
                if (vpc.isOfb === true  &&  typeof vpc.require_fields !== 'undefined'  &&  vpc.require_fields === 'Yes') {
                     var form_is_valid = $('form.formbuilt').validationEngine('validate', {showArrow: false});
                     if (form_is_valid) {
                            save_preview();
                     }
                     else
                        $('#vpc-save-config').removeClass('disabledClick');
                } else
                    save_preview();
      });


      function save_preview() {
	$('#vpc-save-config').addClass('disabledClick');
        var prod_id = $('#vpc-add-to-cart').attr('data-pid');
        var recap = $('#vpc-container').find(':input').serializeJSON();

        var process = wp.hooks.applyFilters('vpc_sci.proceed_save_preview', true);
        if (process) {
          if (vpc.views)
          var decoded_active_views = JSON.parse(active_views);
          var custom_vars = {};
          if (vpc.views) {
            var multiview = true;
            var imgs = get_finish_image_by_view(vpc.vpc_selected_items_selector);
          } else {
            var multiview = false;
            var imgs = get_finish_image(vpc.vpc_selected_items_selector);
          }

          merge_all_images_of_preview(imgs).then(function (status) {
            if (status === 'completed') {
              setTimeout(function () {
                var canvas_data = {};
                if (typeof window.__canvases !== 'undefined' && window.__canvases.length !== 0) {
                  add_custom_texts_and_uploads_datas_on_canvas();
                  var canvases = window.__canvases;
                  canvas_data = get_canvas_data(canvases);
                  recap['canvas_data'] = JSON.stringify(canvas_data);
                }
                custom_vars['preview_imgs_merged'] = JSON.stringify(generate_canvas_images());
                var data_object = {
                  action: "save_sci_canvas_img",
                  multiview: multiview,
                  recap: recap,
                  custom_vars: custom_vars,
                  imgs_by_views: imgs,
                  save_canvas_img_nonce: "save_canvas_img_nonce"
                };
                $.ajax({
                  type: 'POST',
                  url: ajax_object.ajax_url,
                  data: data_object,
                  success: function (result) {
                    nb_images=0;
                    $.ajax({
                      url: ajax_object.ajax_url,
                      type: 'POST',
                      data: {
                        action: 'vpc_sci_save_preview',
                        prod_id: prod_id,
                        multiview: multiview,
                        preview_saved: result,
                        vpc_save_preview_nonce: "vpc_save_preview_nonce"
                      }
                    })
                    .success(function (data) {
                      var ans = JSON.parse(data);
                      if (vpc.views) {
                        vpc_sci_get_previews_multiviews(ans, decoded_active_views);
                      } else {
                        vpc_sci_get_previews(ans);
                      }
                    });
                  }
                });
              }, 200 * nb_images);
            }
          });
        }else {
          wp.hooks.doAction('vpc_sci.proceed_save_preview');
        }
      }
    });
  });


  window.vpc_sci_get_previews_multiviews = function (response, decoded_active_views) {
    new Promise(function (resolve, reject) {
      $('#debug').append($(' <span id="down_link" style="font-size: 15px;">'));
      $.each(response.url, function (key, value) {

        $('#down_link').append('<span><a href="' + value + '" target="_blank">Download ' + decoded_active_views[key] + ' View</a></p>');
      });
      resolve();
    }).then(function () {
      $('#vpc-save-config').removeClass('disabledClick');
    });
  }

  window.vpc_sci_get_previews = function (ans) {
    var urls = ans.url[0];
    $('#save-preview-img').attr('href', urls[0]);
    $('#save-preview-img').attr('download', ans.name + '.png');
    setTimeout(function () {
      $('#save-preview-img')[0].click();
    }, 1000);
    setTimeout(function () {
      $('#vpc-save-config').removeClass('disabledClick');
    }, 1000);
  }
})(jQuery);
