<?php

/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the plugin
 * admin area. This file also includes all of the dependencies used by the plugin,
 * registers the activation and deactivation functions, and defines a function
 * that starts the plugin.
 *
 * @link              https://www.orionorigin.com/product/visual-product-configurator-save-configuration-image-add-on/?utm_source=Installed+pro+plugin&utm_medium=Source+code&utm_campaign=VPC-SCI
 * @since             1.0.1
 * @package           Vpc_Sci
 *
 * @wordpress-plugin
 * Plugin Name:       Visual Products Configurator Save Configuration Image addon
 * Plugin URI:        https://www.orionorigin.com/product/visual-product-configurator-save-configuration-image-add-on/?utm_source=Installed+pro+plugin&utm_medium=Source+code&utm_campaign=VPC-SCI
 * Description:       Allow your customers to download the flattened image of their designs for use outside the product builder.
 * Version:           2.0.1
 * Author:            Orion Origin
 * Author URI:        https://www.orionorigin.com/?utm_source=Installed+pro+plugin&utm_medium=Author+URI&utm_campaign=VPC-SCI
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       vpc-sci
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if (!defined('WPINC')) {
	die;
}
define('VPC_SCI_URL', plugins_url('/', __FILE__));
define('VPC_SCI_DIR', dirname(__FILE__));
define('VPC_SCI_MAIN_FILE', 'visual-product-configurator-save-configuration-image-addon/vpc-sci.php');
define('VPC_SCI_VERSION', '2.0.1');
define('VPC_SCI_NAME', 'Visual Product Configurator Save Configuration Image Add-on');
/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-vpc-sci-activator.php
 */
function activate_vpc_sci()
{
	require_once plugin_dir_path(__FILE__) . 'includes/class-vpc-sci-activator.php';
	Vpc_Sci_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-vpc-sci-deactivator.php
 */
function deactivate_vpc_sci()
{
	require_once plugin_dir_path(__FILE__) . 'includes/class-vpc-sci-deactivator.php';
	Vpc_Sci_Deactivator::deactivate();
}

register_activation_hook(__FILE__, 'activate_vpc_sci');
register_deactivation_hook(__FILE__, 'deactivate_vpc_sci');

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path(__FILE__) . 'includes/class-vpc-sci.php';
require plugin_dir_path(__FILE__) . 'includes/functions.php';


/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
function run_vpc_sci()
{

	$plugin = new Vpc_Sci();
	$plugin->run();
}
run_vpc_sci();
